VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CPropertyByName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Class "PropertyByName" code:

Option Explicit
' All properties of the Class have his variable in an array, _
 instead of a variable each
Private Real_Properties_Variables(1 To 3) As Variant
' The collection "save" an index related to the "Key"
Private Properties_Names As Collection

Private Sub Class_Initialize()
    
    Set Properties_Names = New Collection
    
    ' For each property, add in the collection his index, _
    an store in the "Key" the name of the Property
    Properties_Names.Add 1, "Prop1"
    Properties_Names.Add 2, "Prop2"
    Properties_Names.Add 3, "Prop3"

End Sub

Public Property Let Property_By_Name(ByVal Name As String, ByVal Val As Variant)
    
    ' When i set a property by his name, i take his index _
     and set his variable.
    
    Dim Property_Index As Integer
    Property_Index = Properties_Names(Name)
    Real_Properties_Variables(Property_Index) = Val

End Property
    
Public Property Get Property_By_Name(ByVal Name As String) As Variant
    
    ' When i read a property by his name, i take his index _
     and read his variable.
    
    Dim Property_Index As Integer
    Property_Index = Properties_Names(Name)
    Property_By_Name = Real_Properties_Variables(Property_Index)

End Property

Public Property Get Prop1() As String
    Prop1 = Real_Properties_Variables(1)
End Property

Public Property Let Prop1(ByVal Val As String)
    Real_Properties_Variables(1) = Val
End Property

Public Property Get Prop2() As Integer
    Prop2 = Real_Properties_Variables(2)
End Property

Public Property Let Prop2(ByVal Val As Integer)
    Real_Properties_Variables(2) = Val
End Property

Public Property Get Prop3() As Double
    Prop3 = Real_Properties_Variables(3)
End Property

Public Property Let Prop3(ByVal Val As Double)
    Real_Properties_Variables(3) = Val
End Property
